-----------------------------------------------------------------------------------------------
-- Client Lua Script for HealBuddy
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"

-----------------------------------------------------------------------------------------------
-- HealBuddy Module Definition
-----------------------------------------------------------------------------------------------
local HealBuddy = {} 

-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
local nLastTime, nRefreshTime, fRefresh = 0, 0, 0.016
local bHBcreated = false
local tHBgroupMembers = {}
local nGroupMembers = 0
local bHBenabled = true
local tHBoptions = {25, 50, 75, 90, 25, 34, false}
local HBlowest = nil
local HBfocus = nil
local HBrunning = false
local bHBstarted = true
local fVersion = 1.14
local bDrawLine = false
local bPlayerCheck = true
tHBoptions[0] = {fVersion, bHBenabled, nil}
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function HealBuddy:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 
    return o
end

function HealBuddy:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureButton, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- HealBuddy OnLoad
-----------------------------------------------------------------------------------------------
function HealBuddy:OnLoad()
	Apollo.RegisterSlashCommand("hb", "OnHealBuddyOn", self)
	Apollo.RegisterSlashCommand("hbfocus", "OnHealBuddyFocus", self)
	Apollo.RegisterSlashCommand("hbtarget", "OnHealBuddyTarget", self)
	Apollo.RegisterEventHandler("Group_Join","OnGroupJoin", self)
	Apollo.RegisterEventHandler("Group_Add","OnGroupChanged", self)
	Apollo.RegisterEventHandler("Group_Left","OnGroupLeft", self)
	Apollo.RegisterEventHandler("PlayerChanged","OnGroupChanged", self)
	self.xmlDoc = XmlDoc.CreateFromFile("HealBuddy.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
end

-----------------------------------------------------------------------------------------------
-- HealBuddy OnDocLoaded
-----------------------------------------------------------------------------------------------
function HealBuddy:OnDocLoaded()
	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
		self.wndMain = Apollo.LoadForm("HealBuddy.xml", "Options", nil, self)
		self.Background = Apollo.LoadForm(self.xmlDoc, "Background", "InWorldHudStratum", self)
		self.wndMain:Show(false)
		self:OnGroupChanged()
		if GroupLib.InGroup() then
			self:OnGroupJoin()
		end
	end
end
-----------------------------------------------------------------------------------------------
-- HealBuddy Save and Restore
-----------------------------------------------------------------------------------------------
function HealBuddy:OnSave(eLevel)
    if eLevel ~= GameLib.CodeEnumAddonSaveLevel.Character then
        return nil
    end
	tHBoptions[0][2] = bHBenabled
	tHBoptions[0][3] = bDrawLine
	tHBoptions[0][1] = fVersion
    return tHBoptions
end

function HealBuddy:OnRestore(eLevel, tData)
	if tData then
		if tData[0] then
			if tData[0][1] then
				if tData[0][1] < 1.13 then
					tHBoptions = tData
					bHBenabled = tData[0][2]
					tHBoptions[0][3] = false
					bDrawLine = false
				else
					tHBoptions = tData
					bHBenabled = tData[0][2]
					bDrawLine = tData[0][3]
				end
			end
		end
	end
end
-----------------------------------------------------------------------------------------------
-- HealBuddy Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here

-- on SlashCommand "/hb"
function HealBuddy:OnHealBuddyOn()
	Apollo.RegisterEventHandler("NextFrame", "OnUpdate", self)
	self.wndMain:FindChild("SliderBarRed"):SetValue(tHBoptions[1])
	self.wndMain:FindChild("RedV"):SetText("R: " .. tHBoptions[1])
	self.wndMain:FindChild("SliderBarOrange"):SetValue(tHBoptions[2])
	self.wndMain:FindChild("OrangeV"):SetText("O: " .. tHBoptions[2])
	self.wndMain:FindChild("SliderBarYellow"):SetValue(tHBoptions[3])
	self.wndMain:FindChild("YellowV"):SetText("Y: " .. tHBoptions[3])
	self.wndMain:FindChild("SliderBarGreen"):SetValue(tHBoptions[4])
	self.wndMain:FindChild("GreenV"):SetText("G: " .. tHBoptions[4])
	self.wndMain:FindChild("SliderBarMark"):SetValue(tHBoptions[5])
	self.wndMain:FindChild("MarkV"):SetText("M: " .. tHBoptions[5])
	self.wndMain:FindChild("SliderBarRange"):SetValue(tHBoptions[6])
	self.wndMain:FindChild("RangeV"):SetText("R: " .. tHBoptions[6])
	if bHBenabled then
		self.wndMain:FindChild("Button"):SetCheck(true)
	else
		self.wndMain:FindChild("Button"):SetCheck(false)
	end
	if bDrawLine then
		self.wndMain:FindChild("DrawLine"):SetCheck(true)
	else
		self.wndMain:FindChild("DrawLine"):SetCheck(false)
	end
	self.wndMain:Show(true)
end


function HealBuddy:OnHealBuddyTarget()
	if HBlowest then
		GameLib.SetTargetUnit(HBlowest)
	end
end

function HealBuddy:OnHealBuddyFocus()
	if GameLib.GetTargetUnit() then
		if HBfocus == GameLib.GetTargetUnit():GetId() then
			HBfocus = nil
		else
			HBfocus = GameLib.GetTargetUnit():GetId()
		end
	end
end

function HealBuddy:OnGroupJoin()
	if bHBstarted then
		bHBstarted = false
		Apollo.RegisterEventHandler("NextFrame", "OnUpdate", self)
	end
	self:OnGroupChanged()
end

function HealBuddy:OnGroupLeft()
	Apollo.RemoveEventHandler("NextFrame", self)
	self.Background:DestroyAllPixies()
	bHBstarted = true
	self:OnGroupChanged()
end
function HealBuddy:OnGroupChanged()
	if GroupLib.InGroup() and bHBenabled then
		nGroupMembers = GroupLib.GetMemberCount()
		for i=1, #tHBgroupMembers do
			if tHBgroupMembers[i][3] then
				tHBgroupMembers[i][5]:Show(false)
			end
			if tHBgroupMembers[i][4] then
				tHBgroupMembers[i][6]:Show(false)
				tHBgroupMembers[i][6]:Destroy()
			end
			if tHBgroupMembers[i][9] then
				tHBgroupMembers[i][8]:Show(false)
				tHBgroupMembers[i][8]:Destroy()
			end
			tHBgroupMembers[i] = nil
		end
		tHBgroupMembers = {}
		for i=1, nGroupMembers do
			tHBgroupMembers[i] = {}
			local GroupUnit = GroupLib.GetUnitForGroupMember(i)
			if GroupUnit then
				tHBgroupMembers[i][1] = GroupUnit
		 		tHBgroupMembers[i][2] = math.floor((100 / GroupUnit:GetMaxHealth()) * GroupUnit:GetHealth())
				tHBgroupMembers[i][3] = false
				tHBgroupMembers[i][4] = false
				tHBgroupMembers[i][5] = nil
			else
				tHBgroupMembers[i][2] = 100
			end
				
			tHBgroupMembers[i][6] = Apollo.LoadForm("HealBuddy.xml", "Wings", nil, self)
			tHBgroupMembers[i][6]:Show(false)
			tHBgroupMembers[i][7] = 0
			tHBgroupMembers[i][8] = Apollo.LoadForm("HealBuddy.xml", "FocusArrow", nil, self)
			tHBgroupMembers[i][8]:Show(false)
			tHBgroupMembers[i][9] = false
		end
	else
		for i=1, #tHBgroupMembers do
			if tHBgroupMembers[i][3] then
				tHBgroupMembers[i][5]:Show(false)
				tHBgroupMembers[i][5]:Destroy()
			end
			if tHBgroupMembers[i][4] then
				tHBgroupMembers[i][6]:Show(false)
				tHBgroupMembers[i][6]:Destroy()
			end
			if tHBgroupMembers[i][9] then
				tHBgroupMembers[i][8]:Show(false)
				tHBgroupMembers[i][8]:Destroy()
			end
			tHBgroupMembers[i] = nil
		end
	end
end

function HealBuddy:OnUpdate()
	if bHBenabled then
		local nCurrentTime = GameLib.GetGameTime()
		local nElapsedTime = nCurrentTime - nLastTime
		nLastTime = nCurrentTime
		nRefreshTime = nRefreshTime + nElapsedTime
		if nRefreshTime >= fRefresh then 
			self:OnCreateArrow()
			nRefreshTime = 0
		end
	end
end

function HealBuddy:OnCreateArrow()
	if bHBenabled and GroupLib.InGroup() then
		local unitPlayer = GameLib.GetPlayerUnit()
		if unitPlayer then
			if not unitPlayer:IsDead() then
				HBrunning = true
				local nPlayerFacingAngle = unitPlayer:GetHeading()
				local tPlayerPosition = unitPlayer:GetPosition()
				local tLowest = {unitPlayer, math.floor((100 / unitPlayer:GetMaxHealth()) * unitPlayer:GetHealth())}
				self.Background:DestroyAllPixies()
				for i=1, #tHBgroupMembers do
					local groupMember = GroupLib.GetUnitForGroupMember(i)
					if groupMember and groupMember ~= unitPlayer and not groupMember:IsDead() then
						tHBgroupMembers[i][1] = groupMember
						tHBgroupMembers[i][2] = math.floor((100 / groupMember:GetMaxHealth()) * groupMember:GetHealth())
						local gPos = groupMember:GetPosition()
						local tposition = {tPlayerPosition, gPos}
						local nDeltaX = tposition[2].x - tposition[1].x
						local nDeltaY = tposition[2].y - tposition[1].y
						local nDeltaZ = tposition[2].z - tposition[1].z
						local nHighest = 0
						for q=1, 4 do
							if tHBoptions[q] > nHighest then
								nHighest = tHBoptions[q]
							end
						end
						local nDistance = math.sqrt(math.pow(nDeltaX, 2) + math.pow(nDeltaY, 2) + math.pow(nDeltaZ, 2))
						if tHBgroupMembers[i][2] < tLowest[2] and nDistance <= 34 and not groupMember:IsOccluded()then
							tLowest = {tHBgroupMembers[i][1], tHBgroupMembers[i][2]}
						end
						if not tHBgroupMembers[i][4] and tHBgroupMembers[i][2] <= tHBoptions[5] and nDistance <= tHBoptions[6] then
							tHBgroupMembers[i][6]:SetUnit(groupMember, 1)
							tHBgroupMembers[i][6]:Show(true)
							tHBgroupMembers[i][4] = true
						elseif tHBgroupMembers[i][4] and tHBgroupMembers[i][2] > tHBoptions[5] then
							tHBgroupMembers[i][6]:Show(false)
							tHBgroupMembers[i][4] = false
						end
						if tHBgroupMembers[i][2] <= tHBoptions[1] and nDistance < tHBoptions[6] then
							if tHBgroupMembers[i][3] and tHBgroupMembers[i][7] < 4 then
								tHBgroupMembers[i][5]:Show(false)
							end
							if tHBgroupMembers[i][7] < 4 then
								tHBgroupMembers[i][3] = true
								tHBgroupMembers[i][5] = Apollo.LoadForm("HealBuddy.xml", "RedArrow", nil, self)
								tHBgroupMembers[i][7] = 4
								tHBgroupMembers[i][11] = "red"
							end
						elseif tHBgroupMembers[i][2] <= tHBoptions[2] and nDistance < tHBoptions[6] then
							if tHBgroupMembers[i][7] ~= 3 and tHBgroupMembers[i][3] then
								tHBgroupMembers[i][5]:Show(false)
							end
							if tHBgroupMembers[i][7] ~= 3 then
								tHBgroupMembers[i][3] = true
								tHBgroupMembers[i][5] = Apollo.LoadForm("HealBuddy.xml", "OrangeArrow", nil, self)
								tHBgroupMembers[i][7] = 3
								tHBgroupMembers[i][11] = "xkcdBloodOrange"
							end
						elseif tHBgroupMembers[i][2] <= tHBoptions[3] and nDistance < tHBoptions[6] then
							if tHBgroupMembers[i][7] ~= 2 and tHBgroupMembers[i][3] then
								tHBgroupMembers[i][5]:Show(false)
							end
							if tHBgroupMembers[i][7] ~= 2 then
								tHBgroupMembers[i][3] = true
								tHBgroupMembers[i][5] = Apollo.LoadForm("HealBuddy.xml", "YellowArrow", nil, self)
								tHBgroupMembers[i][7] = 2
								tHBgroupMembers[i][11] = "yellow"
							end
						elseif tHBgroupMembers[i][2] <= tHBoptions[4] and nDistance < tHBoptions[6] then
							if tHBgroupMembers[i][7] ~= 1 and tHBgroupMembers[i][3] then
								tHBgroupMembers[i][5]:Show(false)
							end
							if tHBgroupMembers[i][7] ~= 1 then
								tHBgroupMembers[i][3] = true
								tHBgroupMembers[i][5] = Apollo.LoadForm("HealBuddy.xml", "GreenArrow", nil, self)
								tHBgroupMembers[i][7] = 1
								tHBgroupMembers[i][11] = "green"
							end
						else
							if tHBgroupMembers[i][3] then
								tHBgroupMembers[i][5]:Show(false)
							end
							if tHBgroupMembers[i][9] then
								tHBgroupMembers[i][8]:Show(false)
							end
							tHBgroupMembers[i][9] = false
							tHBgroupMembers[i][3] = false
							tHBgroupMembers[i][7] = 0
						end
						
						if bDrawLine then
							if tHBgroupMembers[i][3] then
								tHBgroupMembers[i][5]:Show(false)
							end
							if nDistance <= tHBoptions[6] and tHBgroupMembers[i][2] <= nHighest then
								local vLine = Vector3.New(gPos.x, gPos.y, gPos.z)
								local spPos = GameLib.WorldLocToScreenPoint(vLine)
								local TWidth = math.floor(self.Background:GetWidth() / 2)
								local THeight = math.floor(self.Background:GetHeight() / 2)
								tHBgroupMembers[i][10] = self.Background:AddPixie( {
									bLine = true, fWidth = 4, cr = tHBgroupMembers[i][11],
									loc = { fPoints = { 0, 0, 0, 0 }, nOffsets = { spPos.x, spPos.y-20, TWidth, THeight } }
								} )
							end
						else
							if nDistance < tHBoptions[6] and tHBgroupMembers[i][3] then
								if groupMember:GetId() == HBfocus  and not tHBgroupMembers[i][9] then
									tHBgroupMembers[i][9] = true
									tHBgroupMembers[i][8]:Show(true)
								elseif groupMember:GetId() ~= HBfocus and tHBgroupMembers[i][9] then
									tHBgroupMembers[i][9] = false
									tHBgroupMembers[i][8]:Show(false)
								elseif tHBgroupMembers[i][9] then
									if not tHBgroupMembers[i][8]:IsShown() then
										tHBgroupMembers[i][8]:Show(true)
									end
								end
							
								local nAngle = math.atan2(nDeltaX, nDeltaZ)
								local nArrowFacingAngle = -nAngle + nPlayerFacingAngle
								local nPositionHorizontal = math.sin(nArrowFacingAngle) * 150
								local nPositionVertical = -math.cos(nArrowFacingAngle) * 150
								
								local nOffsetRight = nPositionHorizontal - 75
								local nOffsetLeft = nPositionHorizontal + 75
								local nOffsetTop = nPositionVertical
								local nOffsetBottom = nPositionVertical - 150
								tHBgroupMembers[i][5]:SetRotation((nArrowFacingAngle * (180 / math.pi)))
								tHBgroupMembers[i][5]:SetAnchorOffsets(-nOffsetLeft, -nOffsetTop, -nOffsetRight, -nOffsetBottom)
								if tHBgroupMembers[i][9] then
									tHBgroupMembers[i][8]:SetRotation((nArrowFacingAngle * (180 / math.pi)))
									tHBgroupMembers[i][8]:SetAnchorOffsets(-nOffsetLeft, -nOffsetTop, -nOffsetRight, -nOffsetBottom)
								end
							end
						end
					else
						if tHBgroupMembers[i][3] then
							tHBgroupMembers[i][5]:Show(false)
							tHBgroupMembers[i][3] = false
						end
						if tHBgroupMembers[i][4] then
							tHBgroupMembers[i][6]:Show(false)
							tHBgroupMembers[i][4] = false
						end
						if tHBgroupMembers[i][9] then
							tHBgroupMembers[i][8]:Show(false)
							tHBgroupMembers[i][9] = false
						end
					end
				end
				HBlowest = tLowest[1]
			elseif HBrunning then 
				for i=1, #tHBgroupMembers do
					if tHBgroupMembers[i][3] then
						tHBgroupMembers[i][5]:Show(false)
					end
					if tHBgroupMembers[i][4] then
						tHBgroupMembers[i][6]:Show(false)
					end
					if tHBgroupMembers[i][9] then
						tHBgroupMembers[i][8]:Show(false)
					end
					tHBgroupMembers[i] = nil
				end
				HBrunning = false
				self.Background:DestroyAllPixies()
			end
			if #tHBgroupMembers ~= nGroupMembers then
				self:OnGroupChanged()
			end
		end
	end
end
---------------------------------------------------------------------------------------------------
-- Options Functions
---------------------------------------------------------------------------------------------------



function HealBuddy:SetThresh( wndHandler, wndControl, fNewValue, fOldValue )
	if wndHandler ~= wndControl then
        return
    end
	local nThresh = math.floor(fNewValue)
	local barname = wndHandler:GetName()
	if barname == "SliderBarRed" then
		self.wndMain:FindChild("RedV"):SetText("R: " .. nThresh)
		tHBoptions[1] = nThresh
	elseif barname == "SliderBarOrange" then
		self.wndMain:FindChild("OrangeV"):SetText("O: " .. nThresh)
		tHBoptions[2] = nThresh
	elseif barname == "SliderBarYellow" then
		self.wndMain:FindChild("YellowV"):SetText("Y: " .. nThresh)
		tHBoptions[3] = nThresh
	elseif barname == "SliderBarGreen" then
		self.wndMain:FindChild("GreenV"):SetText("G: " .. nThresh)
		tHBoptions[4] = nThresh
	elseif barname == "SliderBarMark" then
		self.wndMain:FindChild("MarkV"):SetText("M: " .. nThresh)
		tHBoptions[5] = nThresh
	elseif barname == "SliderBarRange" then
		self.wndMain:FindChild("RangeV"):SetText("R: " .. nThresh)
		tHBoptions[6] = nThresh
	end
end

function HealBuddy:OnEnable()
	if bHBenabled then
		bHBenabled = false
		self:OnGroupChanged()
		self.Background:DestroyAllPixies()
		Print("HealBuddy Disabled")
	else
		bHBenabled = true
		self:OnGroupChanged()
		Print("HealBuddy Enabled")
	end
end


function HealBuddy:OnCreateMacro()
	--if not tHBoptions[0][3] then
		local strName = "Heal Buddy"
	    local strSprite = "IconSprites:Icon_Modifier_endurance_max_001"
	 	local strCmds = "/hbtarget"
	    local id = MacrosLib.CreateMacro()
	    MacrosLib.SetMacroData( id, true, strName, strSprite, strCmds )
		tHBoptions[0][3] = id
	--end
	Event_FireGenericEvent("InterfaceMenu_ToggleMacro")
end

function HealBuddy:OnExit( wndHandler, wndControl, eMouseButton )
	self.wndMain:Show(false)
end

function HealBuddy:OnDrawLine( wndHandler, wndControl, eMouseButton )
	bDrawLine = true
	self:OnGroupChanged()
	tHBoptions[0][3] = true
end

function HealBuddy:OnDrawArrow( wndHandler, wndControl, eMouseButton )
	bDrawLine = false
	self:OnGroupChanged()
	tHBoptions[0][3] = false
end

-----------------------------------------------------------------------------------------------
-- HealBuddy Instance
-----------------------------------------------------------------------------------------------
local HealBuddyInst = HealBuddy:new()
HealBuddyInst:Init()
